import { Player, system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui"

world.afterEvents.itemUse.subscribe( ev => {
    /** @type {Player} */
    const player = ev.source;
    const item = ev.itemStack;

    if( item.typeId === "belytra:wazza_morph" ){
        
        const panel = new ActionFormData();
        panel.title({translate: "belytra.wazza_morph.menu.title"});
        panel.body({translate: "belytra.wazza_morph.menu.body"});
        panel.button({translate: "belytra.wazza_morph.menu.rat_button"}, "textures/menu/rat_icon");
        panel.button({translate: "belytra.wazza_morph.menu.cockcroach_button"}, "textures/menu/cockcroach_icon");
        panel.button({translate: "belytra.wazza_morph.menu.wazza_button"}, "textures/menu/wazza_icon");
        panel.button({translate: "belytra.wazza_morph.menu.reset_button"});

        panel.show(player).then( menu => {
            switch (menu.selection) {
                case 0:
                    player.sendMessage({ translate: "wazza_morph.rat_selected"});
                    player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 belytra:rat_morph`).then(res => {
                        if(res.successCount == 1) {
                            player.runCommandAsync(`effect @s invisibility 9000 1 true`);
                            player.runCommandAsync(`camera @s set minecraft:free pos ~ ~1.5 ~3 facing @s`).then( r => {
                                player.playSound("mob.allay.hurt", {
                                    location: player.location
                                });
                                system.runTimeout(() => {
                                    player.camera.clear();
                                },20);
                            });
                        }
                    });
                    break;
                case 1:
                    player.sendMessage({ translate: "wazza_morph.cockcroach_selected"});
                    player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 belytra:cockcroach_morph`).then(res => {
                        if(res.successCount == 1) {
                            player.runCommandAsync(`effect @s invisibility 9000 1 true`);
                            player.runCommandAsync(`camera @s set minecraft:free pos ~ ~1.5 ~3 facing @s`).then( r => {
                                player.playSound("mob.allay.hurt", {
                                    location: player.location
                                });
                                system.runTimeout(() => {
                                    player.camera.clear();
                                },20);
                            });
                        }
                    });
                    break;
                case 2:
                    player.sendMessage({ translate: "wazza_morph.wazza_selected"});
                    player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 belytra:wazza_morph_item`).then(res => {
                        if(res.successCount == 1) {
                            player.runCommandAsync(`effect @s invisibility 9000 1 true`);
                            player.runCommandAsync(`camera @s set minecraft:free pos ~ ~1.5 ~3 facing @s`).then( r => {
                                player.playSound("mob.allay.hurt", {
                                    location: player.location
                                });
                                system.runTimeout(() => {
                                    player.camera.clear();
                                },20);
                            });
                        }
                    });
                    break;
                case 3:
                    player.sendMessage({ translate: "wazza_morph.reset_selected"});
                    player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 air`).then(res => {
                        if(res.successCount == 1) {
                            player.runCommandAsync(`effect @s clear`);
                            player.playSound("mob.allay.hurt", {
                                location: player.location
                            });
                        }
                    });
                    break;
                default:
                    break;
            }
        });

    }
    
    ev.cancel = true;
});